<?php
/*******************************************************************************

    Author ......... Jimmy Conner
    Contact ........ jimmy@sqmail.org
    Home Site ...... http://sqmail.org
    Program ........ Monitoring for Cacti
    Purpose ........ Simple Whats-Up-Gold replacement

*******************************************************************************/

function plugin_init_monitor() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['monitor'] = 'monitor_show_tab';
	$plugin_hooks['top_graph_header_tabs']['monitor'] = 'monitor_show_tab';
	$plugin_hooks['config_arrays']['monitor'] = 'monitor_config_arrays';
	$plugin_hooks['draw_navigation_text']['monitor'] = 'monitor_draw_navigation_text';
	$plugin_hooks['config_form']['monitor'] = 'monitor_config_form';
	$plugin_hooks['api_device_save']['monitor'] = 'monitor_api_device_save';
	$plugin_hooks['top_graph_refresh']['monitor'] = 'monitor_top_graph_refresh';
	$plugin_hooks['config_settings']['monitor'] = 'monitor_config_settings';
}

function monitor_version () {
	return array( 'name' 		=> 'monitor',
			'version' 	=> '0.7',
			'longname'	=> 'Device Monitoring',
			'author'	=> 'Jimmy Conner',
			'homepage'	=> 'http://cactiusers.org',
			'email'		=> 'jimmy@sqmail.org',
			'url'		=> 'http://cactiusers.org/cacti/versions.php'
			);
}

function monitor_scan_dir () {
	global $config;

	$ext = array('.wav', '.mp3');
	$d = dir($config['base_path'] . "/plugins/monitor/sounds/");
	$files = array();
	while (false !== ($entry = $d->read())) {
		if ($entry != '.' && $entry != '..' && in_array(strtolower(substr($entry,-4)),$ext))
			$files["$entry"] = $entry;
		
	}
	$d->close();
	return $files;
}

function monitor_config_settings () {
	global $tabs, $settings;
	$tabs["misc"] = "Misc";

	$temp = array(
		"monitor_header" => array(
			"friendly_name" => "Monitor",
			"method" => "spacer",
			),
		"monitor_sound" => array(
			"friendly_name" => "Alarm Sound",
			"description" => "This is the sound file that will be played when a host is down.",
			"method" => "drop_array",
			"array" => monitor_scan_dir(),
			"default" => 'attn-noc.wav',
			),
		"monitor_refresh" => array(
			"friendly_name" => "Refresh Interval",
			"description" => "This is the time in seconds before the page refreshes.  (1 - 300)",
			"method" => "textbox",
			"max_length" => 3,
			),
		"monitor_width" => array(
			"friendly_name" => "Icon Spacing",
			"description" => "This is how many icons to show per line.  (1 - 20)",
			"method" => "textbox",
			"max_length" => 3,
			),
		"monitor_legend" => array(
			"friendly_name" => "Show Icon Legend",
			"description" => "Check this to show an icon legend on the Monitor display",
			"method" => "checkbox",
			),
	);

	if (isset($settings["misc"]))
		$settings["misc"] = array_merge($settings["misc"], $temp);
	else
		$settings["misc"]=$temp;
}

function monitor_top_graph_refresh ($refresh) {
	if (basename($_SERVER["PHP_SELF"]) != "monitor.php")
		return $refresh;
	$r = read_config_option("monitor_refresh");
	if ($r == '' or $r < 1)
		return $refresh;
	return $r;
}

function monitor_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('monitor.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('monitor.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/monitor/monitor.php"><img src="' . $config['url_path'] . 'plugins/monitor/images/tab_monitor.gif" alt="Monitor" align="absmiddle" border="0"></a>';

	}
	monitor_setup_table();

	$r = read_config_option("monitor_refresh");
	$sql = "select * from settings where name='monitor_refresh'";
	$result = db_fetch_assoc($sql);
	if (!isset($result[0]['name']))
		$r = NULL;
	if ($r == '' or $r < 1 or $r > 300) {
		if ($r == '')
			$sql = "replace into settings values ('monitor_refresh','300')";
		else if ($r == NULL)
			$sql = "insert into settings values ('monitor_refresh','300')";
		else
			$sql = "update settings set value = '300' where name = 'monitor_refresh'";
		$result = mysql_query($sql) or die (mysql_error());
		kill_session_var("sess_config_array");
	}

	$r = read_config_option("monitor_width");
	$sql = "select * from settings where name='monitor_width'";
	$result = db_fetch_assoc($sql);
	if (!isset($result[0]['name']))
		$r = NULL;
	if ($r == '' or $r < 1 or $r > 20) {
		if ($r == '')
			$sql = "replace into settings values ('monitor_width','10')";
		else if ($r == NULL)
			$sql = "insert into settings values ('monitor_width','10')";
		else
			$sql = "update settings set value = '10' where name = 'monitor_width'";
		$result = mysql_query($sql) or die (mysql_error());
		kill_session_var("sess_config_array");
	}

}

function monitor_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[32]='View Monitoring';
	$user_auth_realm_filenames['monitor.php'] = 32;
}

function monitor_config_form () {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["monitor"] = array(
				"method" => "checkbox",
				"friendly_name" => "Monitor Host",
				"description" => "Check this box to monitor this host on the Monitor Tab.",
				"value" => "|arg1:monitor|",
				"default" => "",
				"form_id" => false
			);
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

function monitor_api_device_save ($save) {
	if (isset($_POST['monitor']))
		$save["monitor"] = form_input_validate($_POST['monitor'], "monitor", "", true, 3);
	else
		$save['monitor'] = form_input_validate('', "monitor", "", true, 3);
	return $save;
}

function monitor_draw_navigation_text ($nav) {
   $nav["monitor.php:"] = array("title" => "Monitoring", "mapping" => "index.php:", "url" => "monitor.php", "level" => "1");
   return $nav;
}

function monitor_setup_table () {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show columns from host from `" . $database_default . "`";
	$result = mysql_query($sql) or die (mysql_error());
	$found = false;
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		if ($row['Field'] == 'monitor')
			$found = true;
	}
	if (!$found) {
		$sql = "alter table host add monitor char(3) default 'on' not null after disabled";
		$result = mysql_query($sql) or die (mysql_error());
		$sql = "INSERT INTO `user_auth_realm` VALUES (32, 1);";
		$result = mysql_query($sql); // or die (mysql_error());
	}
}

?>